#Include <Misc.au3>
#Include <WinAPI.au3>

; ************************************ FUNCTIONS ************************************** 
; ************************************ FUNCTIONS ************************************** 
; ************************************ FUNCTIONS ************************************** 
Func getRGuiHandle()
	$getRWin1 = "[REGEXPTITLE:Console;REGEXPCLASS:R[Gg]ui;]"
	$getRWin2 = "[REGEXPCLASS:R[Gg]ui;]"
	$getRCon2 = "[CLASS:Rgui Document;TEXT:R Console]"
	
	; check if R is there
	$handle = WinGetHandle($getRWin1, "")
	If @error Then
		$handle = ControlGetHandle($getRWin2, "", $getRCon2)
	EndIf

	; Search for a PuTTY window with title "puttyWithAccessR"
	; Start R if not there
	If @error Then
		$handle = WinGetHandle("[CLASS:PuTTY;TITLE:puttyWithAccessR;]", "")

		If @error Then
			Run(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\R-core\R", "InstallPath") & "\bin\Rgui.exe")
			
			WinWait("[REGEXPCLASS:R[Gg]ui;]", "")
			
			$handle = WinGetHandle($getRWin1, "")
			If @error Then
				$handle = ControlGetHandle($getRWin2, "", $getRCon2)
			EndIf
		EndIf
		
		WinActivate($handle)
	EndIf

	If @error Then
		MsgBox(4096, "Error", "Could not find Rgui.exe or putty session 'pspad'.")
	EndIf

	Return($handle)
EndFunc

Func _SendEx($ss,$warn = "")
	; configure key strokes
	BlockInput(1)

	Opt("SendKeyDelay", 0) 
	Opt("SendKeyDownDelay", 0) 
    
	Send($ss, 1) ; send raw keys
	
	BlockInput(0)
    
EndFunc;==>_SendEx

Func _WinGetKeyboardLayout($hWnd)
    Local $aRet = DllCall("user32.dll", "long", "GetWindowThreadProcessId", "hwnd", $hWnd, "ptr", 0)
    $aRet = DllCall("user32.dll", "long", "GetKeyboardLayout", "long", $aRet[0])
   
    Return "0000" & Hex($aRet[0], 4)
	Return $aRet[0]
EndFunc

Func _WinSetKeyboardLayout($sLayoutID, $hWnd)
    Local $WM_INPUTLANGCHANGEREQUEST = 0x50
 
    If StringLen($sLayoutID) <= 3 Then $sLayoutID = "00000" & $sLayoutID
    Local $aRet = DllCall("user32.dll", "long", "LoadKeyboardLayout", "str", $sLayoutID, "int", 0)
 
    DllCall("user32.dll", "ptr", "SendMessage", "hwnd", $hWnd, "int", $WM_INPUTLANGCHANGEREQUEST, "int", 1, "int", $aRet[0])
EndFunc

; *************************************** MAIN **************************************** 
; *************************************** MAIN **************************************** 
; *************************************** MAIN **************************************** 

; Change into the WinTitleMatchMode that supports classnames and handles
AutoItSetOption("WinTitleMatchMode", 4)

; Get the handle of a notepad window that contains "this one"
$handleOld = WinGetHandle("[ACTIVE]", "")

; choose correct lang
$bakOldHkl = _WinGetKeyboardLayout($handleOld)
;_WinSetKeyboardLayout(@KBLayout, $handleOld)

$handle = getRGuiHandle()

; Paste stuff in R
; Send some text directly to this window's edit control
WinActivate($handle)

; choose correct lang
;$bakHkl = _WinGetKeyboardLayout($handle)
;_WinSetKeyboardLayout(@KBLayout, $handle)

; paste stuff
;_SendEx(ClipGet())
While _IsPressed("10") Or _IsPressed("11") Or _IsPressed("12")
  sleep(100)
WEnd

BlockInput(1)

Opt("SendKeyDelay", 10) 
Opt("SendKeyDownDelay", 10)

Send("{SHIFTDOWN}{INS}")
sleep(10)
Send("{SHIFTUP}")
;Send("{ENTER}")


BlockInput(0)

; choose correct lang
;_WinSetKeyboardLayout($bakHkl, $handle)

If $CmdLine[0] > 0 Then
	If $CmdLine[1] == "1" Then
		WinActivate($handleOld)
	EndIf
EndIf

; choose correct lang
;_WinSetKeyboardLayout($bakOldHkl, $handleOld)

